unit U_WarpBeamInfoInPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, StdCtrls, ExtCtrls,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxDateRanges,
  dxBarBuiltInMenu, U_BaseInput, U_BaseList, System.ImageList, Vcl.ImgList,
  dxScrollbarAnnotations, cxContainer, StrUtils, dxSkinsCore,
  dxSkinsDefaultPainters, cxImageList;

type
  TfrmWarpBeamInfoInPut = class(TfrmBaseInput)
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column2: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    ToolButton1: TToolButton;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    Panel1: TPanel;
    cxtxtdtQS: TcxTextEdit;
    cxtxtdtJS: TcxTextEdit;
    Label4: TLabel;
    Label1: TLabel;
    WBType: TcxTextEdit;
    Label2: TLabel;
    WBCoName: TcxTextEdit;
    Label3: TLabel;
    ADOQuery1: TADOQuery;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId, FSTKName: string;
  end;

var
  frmWarpBeamInfoInPut: TfrmWarpBeamInfoInPut;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp;

{$R *.dfm}

procedure TfrmWarpBeamInfoInPut.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmWarpBeamInfoInPut.TBAddClick(Sender: TObject);
var
  I: Integer;
begin
  for I := strtointdef(cxtxtdtQS.Text, 0) to strtointdef(cxtxtdtJS.Text, 0) do
  begin
    with CDS_Sub do
    begin
      Append;

      CDS_Sub.fieldbyname('WBNo').Value := 'JZ' + RightStr(('000' + inttostr(I)), 4);
      CDS_Sub.fieldbyname('WBType').Value := WBType.Text;
      CDS_Sub.fieldbyname('WBCoName').Value := WBCoName.Text;
      Post;
    end;
  end;

end;

function TfrmWarpBeamInfoInPut.SaveCKData(): Boolean;
var
  MaxNo, MWBID, maxno1: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from Tat_WB_Stk where WBID=''' + Trim(CDS_Sub.fieldbyname('WBID').AsString) + '''');
          open;
        end;
        MWBID := Trim(ADOQueryTemp.fieldbyname('WBID').AsString);
        if Trim(MWBID) = '' then
        begin
          if GetLSNo(ADOQueryCmd, MaxNo, 'WB', 'Tat_WB_Stk', 4, 0) = False then
            raise Exception.Create('取最大号失败！');
        end
        else
        begin
          MaxNo := Trim(MWBID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from Tat_WB_Stk where WBID=''' + Trim(MaxNo) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MWBID) = '' then
          begin
            Append;
            FieldByName('Fillid').Value := Trim(Dcode);
            FieldByName('Filler').Value := Trim(DName)
          end
          else
          begin
            Edit;
            FieldByName('Editid').Value := Trim(Dcode);
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          FieldByName('WBID').Value := Trim(MaxNo);
//          FieldByName('STKName').Value := Trim(FSTKName);
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'Tat_WB_Stk', 0);
          Post;
        end;

        if GetLSNo(ADOQuery1, maxno1, 'ZR', 'Tat_WB_IO', 4, 1) = False then
        begin
          Application.MessageBox('取纱线出库编号失败!', '提示', 0);
          Exit;
        end;

        with ADOQueryTemp do
        begin
          close;
          sql.Clear;
          sql.Add('insert into Tat_WB_IO');
          sql.Add('(TWIOID,STKName,IOTime,StkID');
          sql.Add(' ,IOFlag,IOType,StkCoNo,StkCoName,FillId,Filler,WBNo,IOQtyFlag');
          sql.Add(') values(');

          sql.Add(quotedstr(trim(maxno1)));
          sql.Add(',' + quotedstr(trim('空轴')));
          sql.Add(',CONVERT(VARCHAR(10), getdate(),120)  ');
          sql.Add(',' + quotedstr(trim(maxno1)));

          sql.Add(',' + quotedstr(trim('入库')));
          sql.Add(',' + quotedstr(trim('期初入库')));
          sql.Add(',' + quotedstr(trim('本厂仓库')));
          sql.Add(',' + quotedstr(trim('本厂仓库')));
          sql.Add(',' + quotedstr(trim(DCode)));
          sql.Add(',' + quotedstr(trim(DName)));

          sql.Add(',' + quotedstr(trim(CDS_Sub.fieldbyname('WBNo').AsString)));
          sql.Add(',' + trim('1'));

          sql.Add(')');
//        showmessage(sql.text);
          execsql;
        end;

        with ADOQueryCmd do
        begin
          Close;
          Sql.Clear;
          Sql.Add('exec P_TatWB_Stk @TWIOID=' + quotedstr(Trim(maxno1)));
          Open;
        end;
        if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
          raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

        Edit;
        FieldByName('WBID').Value := Trim(MaxNo);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmWarpBeamInfoInPut.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmWarpBeamInfoInPut.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(trim(self.Caption), Tv1, '染色坯布仓库');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from Tat_WB_Stk A');
    sql.Add(' where WBID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
end;

procedure TfrmWarpBeamInfoInPut.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('WBID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;

    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete Tat_WB_Stk where WBID=''' + Trim(CDS_Sub.fieldbyname('WBID').AsString) + '''');
        ExecSQL;
      end;

      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!', '提示', 0);
    end;

  end
  else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmWarpBeamInfoInPut.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;

  if CDS_Sub.Locate('WBNo', null, []) = True then
  begin
    Application.MessageBox('编号不能为空!', '提示', 0);
    Exit;
  end;

  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    ModalResult := 1;
    Exit;
  end;
end;

procedure TfrmWarpBeamInfoInPut.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '染色坯布仓库');
end;

end.

